//
//  PLAppDelegate.m
//  Picturelife iOS SDK
//
//  Created by Glenn Wolters on 04/11/13.
//  Copyright (c) 2013 Glenn Wolters. All rights reserved.
//

#import "PLAppDelegate.h"
#import "PLSession.h"

@implementation PLAppDelegate

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    // these can be found on http://picturelife.com/developers
    NSString *picturelifeAppKey = @"f2967b386f31aec4a783";
    NSString *picturelifeAppSecret = @"e85439c68fd3a69d757cf8e9d05ccd87";

    self.session = [[PLSession alloc] initWithAppKey:picturelifeAppKey appSecret:picturelifeAppSecret];
    BOOL isActiveSession = [self.session authorizeWithSuccessBlock:^(PLSession *session) {
        NSLog(@"Successfully authorized with the Picturelife API - user id: %@ - accesstoken: %@ - expires: %@", session.userID, session.accessToken, session.expireDate);
    } failureBlock:^(NSError *error) {
        NSLog(@"Failed to authorize with the Picturelife API - error code: %i - error description: %@", error.code, [error localizedDescription]);
    }];
    
    if (isActiveSession == YES) {
        NSLog(@"The PLSession stored in the keychain is still active - user id: %@ - accesstoken %@ - expires: %@", self.session.userID, self.session.accessToken, self.session.expireDate);
    }
    else {
        NSLog(@"There was no session stored in the keychain, or the sesssion has expired - starting requests");
    }
    
    self.window = [[UIWindow alloc] initWithFrame:[[UIScreen mainScreen] bounds]];
    // Override point for customization after application launch.
    self.window.backgroundColor = [UIColor whiteColor];
    [self.window makeKeyAndVisible];
    return YES;
}

- (BOOL)application:(UIApplication *)application openURL:(NSURL *)url sourceApplication:(NSString *)sourceApplication annotation:(id)annotation {
    return [self.session handleURL:url];
}

- (void)applicationWillResignActive:(UIApplication *)application
{
    // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
    // Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
    // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
    // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
    // Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
    // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
}

- (void)applicationWillTerminate:(UIApplication *)application
{
    // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
}

@end
